// Generated by CoffeeScript 1.7.1

/*
  Copyright (c) 2014 clowwindy
 
  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:
 
  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.
 
  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
 */

(function() {
  var LocalStrategy, WindowSizeStrategy, events, time, utils,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  events = require('events');

  utils = require('./utils');

  LocalStrategy = (function(_super) {
    __extends(LocalStrategy, _super);

    function LocalStrategy(connections, options) {
      this._connections = connections;
      LocalStrategy.__super__.constructor.call(this);
    }

    return LocalStrategy;

  })(events.EventEmitter);

  time = function() {
    var result;
    result = process.hrtime();
    return result[0] + result[1] * 1e-9;
  };

  WindowSizeStrategy = (function(_super) {
    __extends(WindowSizeStrategy, _super);

    function WindowSizeStrategy(connections, options) {
      var self;
      WindowSizeStrategy.__super__.constructor.call(this, connections, options);
      if (options == null) {
        options = {};
      }
      self = this;
      this._t1 = options.t1 || 10;
      this._t2 = options.t2 || 5;
      setInterval((function() {
        return self._sweep();
      }), options.sweepInterval || 1000);
    }

    WindowSizeStrategy.prototype._sweep = function() {
      var connection, key, keys, now, state, _i, _len, _results;
      keys = Object.keys(this._connections);
      now = time();
      _results = [];
      for (_i = 0, _len = keys.length; _i < _len; _i++) {
        key = keys[_i];
        connection = this._connections[key];
        if (connection._spState == null) {
          state = {};
          connection._spState = state;
          state.lastWindowSizeChange = now;
          state.lastSinkSizeChangeSatisfyingT1 = now;
        }
        state = connection._spState;
        if (state.lastWindowSize !== connection._spdyState.windowSize) {
          state.lastWindowSize = connection._spdyState.windowSize;
          state.lastWindowSizeChange = now;
          utils.debug("updating lastWindowSizeChange");
        }
        if (state.lastSinkSize !== connection._spdyState.sinkSize) {
          state.lastSinkSize = connection._spdyState.sinkSize;
          if (now - state.lastWindowSizeChange >= this._t1) {
            utils.debug("now - state.lastWindowSizeChange >= @_t1");
            if (state.lastSinkSizeChangeSatisfyingT1 < state.lastWindowSizeChange) {
              state.lastSinkSizeChangeSatisfyingT1 = now;
              utils.debug("updating lastSinkSizeChangeSatisfyingT1");
            }
          }
        }
        if (state.lastWindowSizeChange < state.lastSinkSizeChangeSatisfyingT1 && now - state.lastSinkSizeChangeSatisfyingT1 > this._t2) {
          utils.warn("removing dead connection for " + (now - state.lastWindowSizeChange) + " seconds but wrote on " + (now - state.lastSinkSizeChangeSatisfyingT1) + " ago");
          connection = this._connections[key];
          connection.socket.destroy();
          _results.push(delete this._connections[key]);
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    };

    return WindowSizeStrategy;

  })(LocalStrategy);

  exports.WindowSizeStrategy = WindowSizeStrategy;

}).call(this);
